<template>
  <form class="p-2" @submit.prevent="handleSubmit">
    <h2 class="w-full text-center mb-4 text-xl font-semibold">
      {{ formTitle }}
    </h2>
    <div v-for="(field, index) in fields" :key="index">
      <div v-if="field.type === 'select'" class="mb-4">
        <label :for="field.id" class="block text-sm font-medium text-gray-700">{{ field.name }}</label>
        <select :name="field.name" :id="field.id" v-model="field.value"
          class="w-full px-4 py-2 border rounded-lg focus:outline-none focus:ring focus:border-blue-300">
          <option v-for="option in field.options" :value="option.value">{{ option.name }}</option>
        </select>
      </div>
      <div v-else class="mb-4">
        <label :for="field.id" class="block text-sm font-medium text-gray-700">{{ field.name }}</label>
        <input :type="field.type" :id="field.id" :name="field.id" v-model="field.value"
          class="w-full px-4 py-2 border rounded-lg focus:outline-none focus:ring focus:border-blue-300"
          :placeholder="`Enter your ${field.name}`" />
      </div>
    </div>
    <button type="submit"
      class="w-full py-2 px-4 mt-4 bg-blue-500 text-white rounded-lg hover:bg-blue-600 active:bg-blue-900">
      <span v-if="isLoading">
        <Icon name="eos-icons:bubble-loading" class="w-5 h-5" />
        {{ submitName }}
      </span>
      <span v-else>
        <Icon name="material-symbols:save" class="w-5 h-5" />
        {{ submitName }}
      </span>
    </button>
  </form>
</template>

<script>
export default {
  props: {
    formTitle: String,
    submitName: String,
    fields: Array,
    onSubmit: Function,
    isLoading: Boolean
  },
  data() {
    return {};
  },
  methods: {
    handleSubmit() {
      const form = this.fields.reduce((result, current) => {
        result[current.id] = current.value;
        return result;
      }, {});

      if (typeof this.onSubmit === "function") {
        this.onSubmit(form);
      }
    },
  },
};
</script>
